SystemOrganization addCategory: #'Math-Benchmarks-ODE'!

SMarkSuite subclass: #ODEBenchmark
	instanceVariableNames: 'dt function startState startTime endTime'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Benchmarks-ODE'!

ODEBenchmark subclass: #ExplicitBenchmark
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Benchmarks-ODE'!

!ExplicitBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 22:35'!
benchEuler
	|  solver stepper |
	stepper := ExplicitStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 22:35'!
benchHeun
	| solver stepper |
	stepper := HeunStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 22:36'!
benchMidpoint
	| solver stepper |
	stepper := MidpointStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 22:36'!
benchRungeKutta
	| solver stepper |
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitBenchmark methodsFor: 'running' stamp: 'NataliaMoskovchuk 9/2/2013 22:34'!
setUp
	super setUp.
	system := ExplicitSystem block: function.
! !

ODEBenchmark subclass: #ExplicitMultiBenchmark
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Benchmarks-ODE'!

!ExplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:26'!
benchAB2
	| solver stepper |
	stepper := AB2Stepper onSystem: system.
	solver := (AB2Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:27'!
benchAB3
	| solver stepper |
	stepper := AB3Stepper onSystem: system.
	solver := (AB3Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:27'!
benchAB4
	| solver stepper |
	stepper := AB4Stepper onSystem: system.
	solver := (AB4Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ExplicitMultiBenchmark methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/2/2013 00:01'!
setUp
	super setUp.
	system := ExplicitSystem block: function! !

ODEBenchmark subclass: #ImplicitBenchmark
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Benchmarks-ODE'!

!ImplicitBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:26'!
benchImplicitMidpoint
	| solver stepper |
	stepper := ImplicitMidpointStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitBenchmark methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/1/2013 23:59'!
setUp
	super setUp.
	system := ImplicitSystem block: function.! !

ODEBenchmark subclass: #ImplicitMultiBenchmark
	instanceVariableNames: 'system'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Math-Benchmarks-ODE'!

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:27'!
benchAM3
	| solver stepper |
	stepper := AM3Stepper onSystem: system.
	solver := (AM3Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:28'!
benchAM4
	| solver stepper |
	stepper := AM4Stepper onSystem: system.
	solver := (AM4Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:28'!
benchBDF2
	| solver stepper |
	stepper := BDF2Stepper onSystem: system.
	solver := (BDF2Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:29'!
benchBDF3
	| solver stepper |
	stepper := BDF3Stepper onSystem: system.
	solver := (BDF3Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:29'!
benchBDF4
	| solver stepper |
	stepper := BDF4Stepper onSystem: system.
	solver := (BDF4Solver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'benchmarking' stamp: 'NataliaMoskovchuk 9/2/2013 10:30'!
benchTrapezoidAM2
	| solver stepper |
	stepper := TrapezoidStepper onSystem: system.
	solver := (ImplicitSolver new) stepper: stepper; system: system; dt: dt.
	solver solve: system startState: startState startTime:startTime endTime: endTime! !

!ImplicitMultiBenchmark methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/2/2013 00:01'!
setUp
	super setUp.
	system := ImplicitSystem block: function! !

!ODEBenchmark class methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/11/2013 22:56'!
runAll: numOfIterations
	^ (self withAllSubclasses collect: [ :suite |
		suite run: numOfIterations ]) reject: [ :runner |
			runner results isEmpty ]! !

!ODEBenchmark class methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/11/2013 22:57'!
runAllToString: numOfIterations
	^ (self runAll: numOfIterations) joinUsing: Character cr! !

!ODEBenchmark class methodsFor: 'as yet unclassified' stamp: 'NataliaMoskovchuk 9/12/2013 08:45'!
runAllToXML: numOfIterations
	| writer |
	writer := XMLWriter new.
	writer
		enablePrettyPrinting;
		xml.
	writer tag: 'smark' with: [ 
		(self runAll: numOfIterations) do: [ :runner |
			writer tag: 'suite' attributes: { #name -> runner suite class name asString } asDictionary with: [  
				runner results keysAndValuesDo: [ :key :value |
					writer tag: 'benchmark' with: [ 
						writer 
							tag: 'name' with: key;
							tag: 'time' with: ((value inject: 0 into: [ :subTotal :result |
								subTotal + result total ]) / value size) asFloat asString] ] ] ] ].

	^ writer ! !

!ODEBenchmark methodsFor: 'running' stamp: 'NataliaMoskovchuk 9/2/2013 00:04'!
setUp
	dt := 0.005.
	function := [ :x :t | 3 * t exp negated exp - (0.4 * x) + (2 * t * x exp exp) ].
	startState := 5.
	startTime := 0.
	endTime := 1.5! !
